Index: /trunk/libc/Makefile.kmk
===================================================================
--- /trunk/libc/Makefile.kmk	(revision 3697)
+++ /trunk/libc/Makefile.kmk	(revision 3698)
@@ -54,12 +54,12 @@
 libc_frontend_TEMPLATE = libc
 libc_frontend_SOURCES = \
-	$(TARGET_libc_libc) \
-	$(TARGET_libc_fbsdlibc) \
-	$(TARGET_libc_glibc) \
-	$(TARGET_libc_msun)
+	$(libc_libc_1_TARGET) \
+	$(libc_fbsdlibc_1_TARGET) \
+	$(libc_glibc_1_TARGET) \
+	$(libc_msun_1_TARGET)
 #libc_SOURCES.os2 = \
-#	$(TARGET_libc_libsocket) \
-#	$(TARGET_libc_libsyslog)
-libc_SOURCES.nt = $(TARGET_kNIX.nt)
+#	$(libc_libsocket_1_TARGET) \
+#	$(libc_libsyslog_1_TARGET)
+libc_SOURCES.nt = $(kNIX.nt_1_TARGET)
 
 ifdef CFG_LIBC_LOGSTRICT_LIBS
@@ -67,11 +67,11 @@
 libc_frontend_l_TEMPLATE = libc.logstrict
 libc_frontend_l_SOURCES = \
-	$(TARGET_libc_libc_l) \
-	$(TARGET_libc_fbsdlibc_l) \
-	$(TARGET_libc_glibc_l) \
-	$(TARGET_libc_msun_l)
+	$(libc_libc_l_1_TARGET) \
+	$(libc_fbsdlibc_l_1_TARGET) \
+	$(libc_glibc_l_1_TARGET) \
+	$(libc_msun_l_1_TARGET)
 #libc_frontend_l_SOURCES.os2 = \
-#	$(TARGET_libc_libsocket_l) \
-#	$(TARGET_libc_libsyslog_l)
+#	$(libc_libsocket_l_1_TARGET) \
+#	$(libc_libsyslog_l_1_TARGET)
 endif
 
@@ -80,11 +80,11 @@
 libc_frontend_p_TEMPLATE = libc.profiled
 libc_frontend_p_SOURCES = \
-	$(TARGET_libc_libc_p) \
-	$(TARGET_libc_fbsdlibc_p) \
-	$(TARGET_libc_glibc_p) \
-	$(TARGET_libc_msun_p)
+	$(libc_libc_p_1_TARGET) \
+	$(libc_fbsdlibc_p_1_TARGET) \
+	$(libc_glibc_p_1_TARGET) \
+	$(libc_msun_p_1_TARGET)
 #libc_frontend_p_SOURCES.os2 = \
-#	$(TARGET_libc_libsocket_p) \
-#	$(TARGET_libc_libsyslog_p)
+#	$(libc_libsocket_p_1_TARGET) \
+#	$(libc_libsyslog_p_1_TARGET)
 endif
 
@@ -96,8 +96,8 @@
 libc_frontend_asm_TEMPLATE = libcasm
 libc_frontend_asm_SOURCES = \
-	$(TARGET_libc_libc_asm) \
-	$(TARGET_libc_fbsdlibc_asm) \
-	$(TARGET_libc_glibc_asm) \
-	$(TARGET_libc_msun_asm)
+	$(libc_libc_asm_1_TARGET) \
+	$(libc_fbsdlibc_asm_1_TARGET) \
+	$(libc_glibc_asm_1_TARGET) \
+	$(libc_msun_asm_1_TARGET)
 
 ifdef CFG_LIBC_LOGSTRICT_LIBS
@@ -105,8 +105,8 @@
 libc_frontend_asm_l_TEMPLATE = libcasm.logstrict
 libc_frontend_asm_l_SOURCES = \
-	$(TARGET_libc_libc_asm_l) \
-	$(TARGET_libc_fbsdlibc_asm_l) \
-	$(TARGET_libc_glibc_asm_l) \
-	$(TARGET_libc_msun_asm_l)
+	$(libc_libc_asm_l_1_TARGET) \
+	$(libc_fbsdlibc_asm_l_1_TARGET) \
+	$(libc_glibc_asm_l_1_TARGET) \
+	$(libc_msun_asm_l_1_TARGET)
 endif
 
@@ -115,8 +115,8 @@
 libc_frontend_asm_p_TEMPLATE = libcasm.profiled
 libc_frontend_asm_p_SOURCES = \
-	$(TARGET_libc_libc_asm_p) \
-	$(TARGET_libc_fbsdlibc_asm_p) \
-	$(TARGET_libc_glibc_asm_p) \
-	$(TARGET_libc_msun_asm_p)
+	$(libc_libc_asm_p_1_TARGET) \
+	$(libc_fbsdlibc_asm_p_1_TARGET) \
+	$(libc_glibc_asm_p_1_TARGET) \
+	$(libc_msun_asm_p_1_TARGET)
 endif
 
@@ -128,7 +128,7 @@
 libc_s_TEMPLATE = libc
 libc_s_SOURCES = \
-	$(TARGET_libc_frontend) \
-	$(TARGET_libc_kNIX)
-libc_s_SOURCES.nt = $(TARGET_kNIX.nt)
+	$(libc_frontend_1_TARGET) \
+	$(libc_kNIX_1_TARGET)
+libc_s_SOURCES.nt = $(kNIX.nt_1_TARGET)
 
 ifdef CFG_LIBC_LOGSTRICT_LIBS
@@ -136,7 +136,7 @@
 libc_s_l_TEMPLATE = libc.profiled
 libc_s_l_SOURCES = \
-	$(TARGET_libc_frontend_l) \
-	$(TARGET_libc_kNIX_l)
-libc_s_l_SOURCES.nt = $(TARGET_kNIX_l.nt)
+	$(libc_frontend_l_1_TARGET) \
+	$(libc_kNIX_l_1_TARGET)
+libc_s_l_SOURCES.nt = $(kNIX_l.nt_1_TARGET)
 endif
 
@@ -145,7 +145,7 @@
 libc_s_p_TEMPLATE = libc.profiled
 libc_s_p_SOURCES = \
-	$(TARGET_libc_frontend_p) \
-	$(TARGET_libc_kNIX_p)
-libc_s_p_SOURCES.nt = $(TARGET_kNIX_p.nt)
+	$(libc_frontend_p_1_TARGET) \
+	$(libc_kNIX_p_1_TARGET)
+libc_s_p_SOURCES.nt = $(kNIX_p.nt_1_TARGET)
 endif
 
@@ -157,6 +157,6 @@
 libc_asm_TEMPLATE = libcasm
 libc_asm_SOURCES = \
-	$(TARGET_libc_frontend_asm) \
-	$(TARGET_libc_kNIX_asm)
+	$(libc_frontend_asm_1_TARGET) \
+	$(libc_kNIX_asm_1_TARGET)
 
 ifdef CFG_LIBC_LOGSTRICT_LIBS
@@ -164,6 +164,6 @@
 libc_asm_l_TEMPLATE = libcasm.logstrict
 libc_asm_l_SOURCES = \
-	$(TARGET_libc_frontend_asm_l) \
-	$(TARGET_libc_kNIX_asm_l)
+	$(libc_frontend_asm_l_1_TARGET) \
+	$(libc_kNIX_asm_l_1_TARGET)
 endif
 
@@ -172,6 +172,6 @@
 libc_asm_p_TEMPLATE = libcasm.profiled
 libc_asm_p_SOURCES = \
-	$(TARGET_libc_frontend_asm_p) \
-	$(TARGET_libc_kNIX_asm_p)
+	$(libc_frontend_asm_p_1_TARGET) \
+	$(libc_kNIX_asm_p_1_TARGET)
 endif
 
@@ -189,8 +189,8 @@
 libc07_LDFLAGS = -g -Zomf -nostdlib
 libc07_LIBS = \
-	$(TARGET_libc_s) \
-	$(TARGET_libc_asm) \
-	$(TARGET_libos2_unicode_lazy) \
-	$(TARGET_libos2) \
+	$(libc_s_1_TARGET) \
+	$(libc_asm_1_TARGET) \
+	$(libos2_unicode_lazy_1_TARGET) \
+	$(libos2_1_TARGET) \
 	$(PATH_TARGET)/libc_alias/libc_alias.a \
 	gcc \
@@ -209,8 +209,8 @@
 libc07.logstrict_LDFLAGS = -g -Zomf -nostdlib
 libc07.logstrict_LIBS = \
-	$(TARGET_libc_s_l) \
-	$(TARGET_libc_asm_l) \
-	$(TARGET_libos2_unicode_lazy) \
-	$(TARGET_libos2_l) \
+	$(libc_s_l_1_TARGET) \
+	$(libc_asm_l_1_TARGET) \
+	$(libos2_unicode_lazy_1_TARGET) \
+	$(libos2_l_1_TARGET) \
 	$(PATH_TARGET)/libc_alias/libc_alias.a \
 	gcc \
@@ -230,8 +230,8 @@
 libc07.profiled_LDFLAGS = -g -Zomf -nostdlib
 libc07.profiled_LIBS = \
-	$(TARGET_libc_s_p) \
-	$(TARGET_libc_asm_p) \
-	$(TARGET_libos2_unicode_lazy) \
-	$(TARGET_libos2_p) \
+	$(libc_s_p_1_TARGET) \
+	$(libc_asm_p_1_TARGET) \
+	$(libos2_unicode_lazy_1_TARGET) \
+	$(libos2_p_1_TARGET) \
 	$(PATH_TARGET)/libc_alias/libc_alias.a \
 	gcc \
@@ -260,5 +260,5 @@
 #
 $(PATH_TARGET)/libc.def: \
-		$$(TARGET_libc_s) \
+		$$(libc_s_1_TARGET) \
 		$$(PATH_LIBC_SRC)/libc/libc.def
 	$(RM) -f $@ $@.tmp.def
@@ -268,5 +268,5 @@
 	$(APPEND) $@.tmp.def "CODE SHARED"
 	$(APPEND) $@.tmp.def "EXPORTS"
-	emxexp $(TARGET_libc_s) \
+	emxexp $(libc_s_1_TARGET) \
 		| $(SED) -e "/\"___pfn/d" -e "/\"__sys_/d" -e "/\"___sys_/d" -e "/\"___libc_[a-z]/d" -e "/\"__nsyy/d" \
 		>> $@.tmp.def
Index: /trunk/libc/src/fbsdlibc/Makefile.kmk
===================================================================
--- /trunk/libc/src/fbsdlibc/Makefile.kmk	(revision 3697)
+++ /trunk/libc/src/fbsdlibc/Makefile.kmk	(revision 3698)
@@ -44,10 +44,10 @@
 libc_fbsdlibc_TEMPLATE = libcsub
 libc_fbsdlibc_SOURCES := \
-	$(foreach sublib,$(LIBC_SUB_LIBRARIES), $(PATH_$(sublib))/$(sublib).a)
+	$(foreach sublib,$(LIBC_SUB_LIBRARIES), $($(sublib)_0_OUTDIR)/$(sublib).a)
 ifdef CFG_LIBC_LOGSTRICT_LIBS
 LIBRARIES += libc_fbsdlibc_l
 libc_fbsdlibc_l_TEMPLATE = libcsub
 libc_fbsdlibc_l_SOURCES := \
-	$(foreach sublib,$(LIBC_SUB_LIBRARIES), $(PATH_$(sublib)_l)/$(sublib)_l.a)
+	$(foreach sublib,$(LIBC_SUB_LIBRARIES), $($(sublib)_l_0_OUTDIR)/$(sublib)_l.a)
 endif
 ifdef CFG_LIBC_PROFILED_LIBS
@@ -55,5 +55,5 @@
 libc_fbsdlibc_p_TEMPLATE = libcsub
 libc_fbsdlibc_p_SOURCES := \
-	$(foreach sublib,$(LIBC_SUB_LIBRARIES), $(PATH_$(sublib)_p)/$(sublib)_p.a)
+	$(foreach sublib,$(LIBC_SUB_LIBRARIES), $($(sublib)_p_0_OUTDIR)/$(sublib)_p.a)
 endif
 
Index: /trunk/libc/src/fbsdlibc/gdtoa/Makefile.kmk
===================================================================
--- /trunk/libc/src/fbsdlibc/gdtoa/Makefile.kmk	(revision 3697)
+++ /trunk/libc/src/fbsdlibc/gdtoa/Makefile.kmk	(revision 3698)
@@ -34,5 +34,5 @@
 libc_fbsdlibc_gdtoa_TEMPLATE = libcsub
 libc_fbsdlibc_gdtoa_INCS = $(PATH_LIBC_SRC)/fbsdlibc/include $(PATH_TARGET)
-libc_fbsdlibc_gdtoa_DEPS = $(TARGET_arithchk) $(PATH_TARGET)/arith.h
+libc_fbsdlibc_gdtoa_DEPS = $(arithchk_1_TARGET) $(PATH_TARGET)/arith.h
 libc_fbsdlibc_gdtoa_SOURCES = \
 	$(PATH_LIBC_SRC)/fbsdlibc/gdtoa/dmisc.c \
@@ -92,5 +92,5 @@
 
 # generate arith.h
-$(PATH_TARGET)/arith.h: $$(TARGET_arithchk)
+$(PATH_TARGET)/arith.h: $$(arithchk_1_TARGET)
 	$(TEST) -n $<  -a  -f $<
 	$< > $@.tmp
Index: /trunk/libc/src/libc/conv/Makefile.kmk
===================================================================
--- /trunk/libc/src/libc/conv/Makefile.kmk	(revision 3697)
+++ /trunk/libc/src/libc/conv/Makefile.kmk	(revision 3698)
@@ -90,5 +90,5 @@
 
 # Generate the big integer tables.
-$(PATH_TARGET)/bipow5.tab: $$(TARGET_makepow5) | $(call DIRDEP,$(PATH_TARGET))
+$(PATH_TARGET)/bipow5.tab: $$(makepow5_1_TARGET) | $(call DIRDEP,$(PATH_TARGET))
 	$< -o $@ -s -m325 4951
 