Index: trunk/src/user32/dc.cpp
===================================================================
--- trunk/src/user32/dc.cpp	(revision 3721)
+++ trunk/src/user32/dc.cpp	(revision 3722)
@@ -1,3 +1,3 @@
-/* $Id: dc.cpp,v 1.61 2000-06-14 14:25:56 sandervl Exp $ */
+/* $Id: dc.cpp,v 1.62 2000-06-17 09:45:00 sandervl Exp $ */
 
 /*
@@ -885,5 +885,5 @@
    {
       ULONG BytesNeeded;
-      PRGNDATA_W RgnData;
+      PRGNDATA RgnData;
       PRECT pr;
       int i;
@@ -1053,5 +1053,5 @@
    {
       ULONG BytesNeeded;
-      PRGNDATA_W RgnData;
+      PRGNDATA RgnData;
       PRECTL pr;
       int i;
@@ -1066,9 +1066,9 @@
          goto error;
 
-      BytesNeeded = O32_GetRegionData (hrgn, 0, NULL);
-      RgnData = (PRGNDATA_W)_alloca (BytesNeeded);
+      BytesNeeded = GetRegionData (hrgn, 0, NULL);
+      RgnData = (PRGNDATA)_alloca (BytesNeeded);
       if (RgnData == NULL)
           goto error;
-      O32_GetRegionData (hrgn, BytesNeeded, RgnData);
+      GetRegionData (hrgn, BytesNeeded, RgnData);
 
       pr = (PRECTL)(RgnData->Buffer);
@@ -1107,6 +1107,7 @@
             success = WinInvalidateRect (hwnd, NULL, IncludeChildren);
         else
-        if (hrgn)
+        if (hrgn) {
             success = WinInvalidateRegion (hwnd, hrgnTemp, IncludeChildren);
+        }
         else
             success = WinInvalidateRect (hwnd, &rectl, IncludeChildren);
@@ -1124,6 +1125,7 @@
                 success = WinValidateRect (hwnd, NULL, IncludeChildren);
             else
-            if (hrgn)
+            if (hrgn) {
                 success = WinValidateRegion (hwnd, hrgnTemp, IncludeChildren);
+            }
             else
                 success = WinValidateRect (hwnd, &rectl, IncludeChildren);
@@ -1237,8 +1239,8 @@
          rc = GpiQueryRegionRects (hps, hrgnPM, NULL, &rgnRect, Rcls);
 
-         rc = O32_SetRectRgn (hrgnWin, pRcl->xLeft,
-                                        pRcl->xRight,
-                                        height - pRcl->yTop,
-                                        height - pRcl->yBottom);
+         rc = SetRectRgn(hrgnWin, pRcl->xLeft,
+                         pRcl->xRight,
+                         height - pRcl->yTop,
+                         height - pRcl->yBottom);
 
          if (rgnRect.crcReturned > 1)
@@ -1246,15 +1248,15 @@
             int i;
             HRGN temp;
-            temp = O32_CreateRectRgn (0, 0, 1, 1);
+            temp = CreateRectRgn (0, 0, 1, 1);
 
             for (i = 1, pRcl++; rc && (i < rgnRect.crcReturned); i++, pRcl++)
             {
-              rc = O32_SetRectRgn (temp, pRcl->xLeft,
-                                          pRcl->xRight,
-                                          height - pRcl->yTop,
-                                          height - pRcl->yBottom);
-              rc &= O32_CombineRgn (hrgnWin, hrgnWin, temp, RGN_OR_W);
+              rc = SetRectRgn (temp, pRcl->xLeft,
+                               pRcl->xRight,
+                               height - pRcl->yTop,
+                               height - pRcl->yBottom);
+              rc &= CombineRgn (hrgnWin, hrgnWin, temp, RGN_OR_W);
             }
-            O32_DeleteObject (temp);
+            DeleteObject (temp);
          }
          delete[] Rcls;
@@ -1267,5 +1269,5 @@
    else
    {
-      rc = O32_SetRectRgn (hrgnWin, 0, 0, 0, 0);
+      rc = SetRectRgn (hrgnWin, 0, 0, 0, 0);
    }
 
Index: trunk/src/user32/dc.h
===================================================================
--- trunk/src/user32/dc.h	(revision 3721)
+++ trunk/src/user32/dc.h	(revision 3722)
@@ -1,3 +1,3 @@
-/* $Id: dc.h,v 1.14 2000-06-08 18:10:09 sandervl Exp $ */
+/* $Id: dc.h,v 1.15 2000-06-17 09:45:02 sandervl Exp $ */
 /*
  * public dc functions
@@ -111,19 +111,4 @@
 #define RDW_FRAME_W            0x0400
 #define RDW_NOFRAME_W          0x0800
-
-typedef struct _RGNDATAHEADER_W {
-    DWORD       dwSize;
-    DWORD       iType;
-    DWORD       nCount;
-    DWORD       nRgnSize;
-    RECT        rcBound;
-} RGNDATAHEADER_W, *LPRGNDATAHEADER_W;
-
-typedef struct _RGNDATA_W {
-    RGNDATAHEADER_W     rdh;
-    char                Buffer[1];
-} RGNDATA_W , *PRGNDATA_W , *LPRGNDATA_W ;
-
-
 /* Xform FLAGS */
 #define MWT_IDENTITY_W        1
@@ -257,16 +242,4 @@
 }
 
-ULONG   OPEN32API _O32_GetRegionData (HRGN hrgn, ULONG count, PRGNDATA_W pData);
-
-inline DWORD O32_GetRegionData(HRGN a, DWORD b, PRGNDATA_W c)
-{
- DWORD yyrc;
- USHORT sel = RestoreOS2FS();
-
-    yyrc = _O32_GetRegionData(a, b, c);
-    SetFS(sel);
-
-    return yyrc;
-}
 
 BOOL    OPEN32API _O32_DeleteObject (LHANDLE hgdiobj);
@@ -304,43 +277,4 @@
     _O32_SetLastError(a);
     SetFS(sel);
-}
-
-BOOL    OPEN32API _O32_SetRectRgn (HRGN dest, int left, int top, int right, int bottom);
-
-inline BOOL O32_SetRectRgn(HRGN a, int b, int c, int d, int e)
-{
- BOOL yyrc;
- USHORT sel = RestoreOS2FS();
-
-    yyrc = _O32_SetRectRgn(a, b, c, d, e);
-    SetFS(sel);
-
-    return yyrc;
-}
-
-int     OPEN32API _O32_CombineRgn (HRGN dest, HRGN src1, HRGN src2, int mode);
-
-inline int O32_CombineRgn(HRGN a, HRGN b, HRGN c, int d)
-{
- int yyrc;
- USHORT sel = RestoreOS2FS();
-
-    yyrc = _O32_CombineRgn(a, b, c, d);
-    SetFS(sel);
-
-    return yyrc;
-}
-
-HRGN    OPEN32API _O32_CreateRectRgn (int left, int top, int right, int bottom);
-
-inline HRGN O32_CreateRectRgn(int a, int b, int c, int d)
-{
- HRGN yyrc;
- USHORT sel = RestoreOS2FS();
-
-    yyrc = _O32_CreateRectRgn(a, b, c, d);
-    SetFS(sel);
-
-    return yyrc;
 }
 