Index: /branches/libc-0.6/src/emx/src/lib/sys/b_fsFileModeSetFH.c
===================================================================
--- /branches/libc-0.6/src/emx/src/lib/sys/b_fsFileModeSetFH.c	(revision 3777)
+++ /branches/libc-0.6/src/emx/src/lib/sys/b_fsFileModeSetFH.c	(revision 3778)
@@ -151,5 +151,5 @@
                 } EAs =
                 {
-                    sizeof(EAs), 0, FEA_NEEDEA, sizeof(EA_MODE) - 1, sizeof(uint32_t) + 4, EA_MODE, EAT_BINARY, sizeof(uint32_t), Mode
+                    sizeof(EAs), 0, 0, sizeof(EA_MODE) - 1, sizeof(uint32_t) + 4, EA_MODE, EAT_BINARY, sizeof(uint32_t), Mode
                 };
                 #pragma pack()
Index: /branches/libc-0.6/src/emx/src/lib/sys/b_fsNativeFileModeSet.c
===================================================================
--- /branches/libc-0.6/src/emx/src/lib/sys/b_fsNativeFileModeSet.c	(revision 3777)
+++ /branches/libc-0.6/src/emx/src/lib/sys/b_fsNativeFileModeSet.c	(revision 3778)
@@ -194,5 +194,5 @@
             } EAs =
             {
-                sizeof(EAs), 0, FEA_NEEDEA, sizeof(EA_MODE) - 1, sizeof(uint32_t) + 4, EA_MODE, EAT_BINARY, sizeof(uint32_t), Mode
+                sizeof(EAs), 0, 0, sizeof(EA_MODE) - 1, sizeof(uint32_t) + 4, EA_MODE, EAT_BINARY, sizeof(uint32_t), Mode
             };
             #pragma pack()
Index: /branches/libc-0.6/src/emx/src/lib/sys/b_nativeSymlinkCreate.c
===================================================================
--- /branches/libc-0.6/src/emx/src/lib/sys/b_nativeSymlinkCreate.c	(revision 3777)
+++ /branches/libc-0.6/src/emx/src/lib/sys/b_nativeSymlinkCreate.c	(revision 3778)
@@ -69,13 +69,13 @@
     {
         sizeof(__libc_gFsUnixAttribsCreateSymlinkFEA2List),
-        OFF(Core.offGID,    Core.offUID),   FEA_NEEDEA,  sizeof(EA_UID) - 1,   sizeof(uint32_t) + 4, EA_UID,   EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(Core.offMode,   Core.offGID),   FEA_NEEDEA,  sizeof(EA_GID) - 1,   sizeof(uint32_t) + 4, EA_GID,   EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(Core.offINO,    Core.offMode),  FEA_NEEDEA,  sizeof(EA_MODE) - 1,  sizeof(uint32_t) + 4, EA_MODE,  EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(Core.offRDev,   Core.offINO),   FEA_NEEDEA,  sizeof(EA_INO) - 1,   sizeof(uint64_t) + 4, EA_INO,   EAT_BINARY, sizeof(uint64_t), 0, "",
-        OFF(Core.offGen,    Core.offRDev),  FEA_NEEDEA,  sizeof(EA_RDEV) - 1,  sizeof(uint32_t) + 4, EA_RDEV,  EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(Core.offFlags,  Core.offGen),   FEA_NEEDEA,  sizeof(EA_GEN) - 1,   sizeof(uint32_t) + 4, EA_GEN,   EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(offSymlink,     Core.offFlags), FEA_NEEDEA,  sizeof(EA_FLAGS) - 1, sizeof(uint32_t) + 4, EA_FLAGS, EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offGID,    Core.offUID),   0,  sizeof(EA_UID) - 1,   sizeof(uint32_t) + 4, EA_UID,   EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offMode,   Core.offGID),   0,  sizeof(EA_GID) - 1,   sizeof(uint32_t) + 4, EA_GID,   EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offINO,    Core.offMode),  0,  sizeof(EA_MODE) - 1,  sizeof(uint32_t) + 4, EA_MODE,  EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offRDev,   Core.offINO),   0,  sizeof(EA_INO) - 1,   sizeof(uint64_t) + 4, EA_INO,   EAT_BINARY, sizeof(uint64_t), 0, "",
+        OFF(Core.offGen,    Core.offRDev),  0,  sizeof(EA_RDEV) - 1,  sizeof(uint32_t) + 4, EA_RDEV,  EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offFlags,  Core.offGen),   0,  sizeof(EA_GEN) - 1,   sizeof(uint32_t) + 4, EA_GEN,   EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(offSymlink,     Core.offFlags), 0,  sizeof(EA_FLAGS) - 1, sizeof(uint32_t) + 4, EA_FLAGS, EAT_BINARY, sizeof(uint32_t), 0, "",
     },
-    0,                                      FEA_NEEDEA,  sizeof(EA_SYMLINK) - 1, 0              + 4, EA_SYMLINK,EAT_ASCII, 0,                ""
+    0,                                      0,  sizeof(EA_SYMLINK) - 1, 0              + 4, EA_SYMLINK,EAT_ASCII, 0,                ""
 #undef OFF
 };
Index: /branches/libc-0.6/src/emx/src/lib/sys/fs.c
===================================================================
--- /branches/libc-0.6/src/emx/src/lib/sys/fs.c	(revision 3777)
+++ /branches/libc-0.6/src/emx/src/lib/sys/fs.c	(revision 3778)
@@ -167,11 +167,11 @@
 #define OFF(a,b)  offsetof(struct __LIBC_FSUNIXATTRIBSCREATEFEA2LIST, a)  - offsetof(struct __LIBC_FSUNIXATTRIBSCREATEFEA2LIST, b)
     sizeof(__libc_gFsUnixAttribsCreateFEA2List),
-    OFF(offGID,    offUID),   FEA_NEEDEA,  sizeof(EA_UID) - 1,   sizeof(uint32_t) + 4, EA_UID,   EAT_BINARY, sizeof(uint32_t), 0, "",
-    OFF(offMode,   offGID),   FEA_NEEDEA,  sizeof(EA_GID) - 1,   sizeof(uint32_t) + 4, EA_GID,   EAT_BINARY, sizeof(uint32_t), 0, "",
-    OFF(offINO,    offMode),  FEA_NEEDEA,  sizeof(EA_MODE) - 1,  sizeof(uint32_t) + 4, EA_MODE,  EAT_BINARY, sizeof(uint32_t), 0, "",
-    OFF(offRDev,   offINO),   FEA_NEEDEA,  sizeof(EA_INO) - 1,   sizeof(uint64_t) + 4, EA_INO,   EAT_BINARY, sizeof(uint64_t), 0, "",
-    OFF(offGen,    offRDev),  FEA_NEEDEA,  sizeof(EA_RDEV) - 1,  sizeof(uint32_t) + 4, EA_RDEV,  EAT_BINARY, sizeof(uint32_t), 0, "",
-    OFF(offFlags,  offGen),   FEA_NEEDEA,  sizeof(EA_GEN) - 1,   sizeof(uint32_t) + 4, EA_GEN,   EAT_BINARY, sizeof(uint32_t), 0, "",
-    0,                        FEA_NEEDEA,  sizeof(EA_FLAGS) - 1, sizeof(uint32_t) + 4, EA_FLAGS, EAT_BINARY, sizeof(uint32_t), 0, ""
+    OFF(offGID,    offUID),   0,  sizeof(EA_UID) - 1,   sizeof(uint32_t) + 4, EA_UID,   EAT_BINARY, sizeof(uint32_t), 0, "",
+    OFF(offMode,   offGID),   0,  sizeof(EA_GID) - 1,   sizeof(uint32_t) + 4, EA_GID,   EAT_BINARY, sizeof(uint32_t), 0, "",
+    OFF(offINO,    offMode),  0,  sizeof(EA_MODE) - 1,  sizeof(uint32_t) + 4, EA_MODE,  EAT_BINARY, sizeof(uint32_t), 0, "",
+    OFF(offRDev,   offINO),   0,  sizeof(EA_INO) - 1,   sizeof(uint64_t) + 4, EA_INO,   EAT_BINARY, sizeof(uint64_t), 0, "",
+    OFF(offGen,    offRDev),  0,  sizeof(EA_RDEV) - 1,  sizeof(uint32_t) + 4, EA_RDEV,  EAT_BINARY, sizeof(uint32_t), 0, "",
+    OFF(offFlags,  offGen),   0,  sizeof(EA_GEN) - 1,   sizeof(uint32_t) + 4, EA_GEN,   EAT_BINARY, sizeof(uint32_t), 0, "",
+    0,                        0,  sizeof(EA_FLAGS) - 1, sizeof(uint32_t) + 4, EA_FLAGS, EAT_BINARY, sizeof(uint32_t), 0, ""
 #undef OFF
 };
@@ -441,5 +441,5 @@
     }
     DosFreeModule(hmod);
-    
+
     /*
      * Look for the UNIX EAs control environment variable.
@@ -714,5 +714,5 @@
     pFEA->cbName            = sizeof(EA_SYMLINK) - 1;
     pFEA->cbValue           = cchTarget + sizeof(USHORT) * 2;
-    pFEA->fEA               = FEA_NEEDEA;
+    pFEA->fEA               = 0;
     memcpy(pFEA->szName, EA_SYMLINK, sizeof(EA_SYMLINK));
     PUSHORT pus = (PUSHORT)&pFEA->szName[sizeof(EA_SYMLINK)];
Index: /trunk/libc/src/kNIX/os2/b_fsNativeFileModeSet.c
===================================================================
--- /trunk/libc/src/kNIX/os2/b_fsNativeFileModeSet.c	(revision 3777)
+++ /trunk/libc/src/kNIX/os2/b_fsNativeFileModeSet.c	(revision 3778)
@@ -177,5 +177,5 @@
             } EAs =
             {
-                sizeof(EAs), 0, FEA_NEEDEA, sizeof(EA_MODE) - 1, sizeof(uint32_t) + 4, EA_MODE, EAT_BINARY, sizeof(uint32_t), Mode
+                sizeof(EAs), 0, 0, sizeof(EA_MODE) - 1, sizeof(uint32_t) + 4, EA_MODE, EAT_BINARY, sizeof(uint32_t), Mode
             };
             #pragma pack()
Index: /trunk/libc/src/kNIX/os2/b_nativeSymlinkCreate.c
===================================================================
--- /trunk/libc/src/kNIX/os2/b_nativeSymlinkCreate.c	(revision 3777)
+++ /trunk/libc/src/kNIX/os2/b_nativeSymlinkCreate.c	(revision 3778)
@@ -59,13 +59,13 @@
     {
         sizeof(__libc_gFsUnixAttribsCreateSymlinkFEA2List),
-        OFF(Core.offGID,    Core.offUID),   FEA_NEEDEA,  sizeof(EA_UID) - 1,   sizeof(uint32_t) + 4, EA_UID,   EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(Core.offMode,   Core.offGID),   FEA_NEEDEA,  sizeof(EA_GID) - 1,   sizeof(uint32_t) + 4, EA_GID,   EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(Core.offINO,    Core.offMode),  FEA_NEEDEA,  sizeof(EA_MODE) - 1,  sizeof(uint32_t) + 4, EA_MODE,  EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(Core.offRDev,   Core.offINO),   FEA_NEEDEA,  sizeof(EA_INO) - 1,   sizeof(uint64_t) + 4, EA_INO,   EAT_BINARY, sizeof(uint64_t), 0, "",
-        OFF(Core.offGen,    Core.offRDev),  FEA_NEEDEA,  sizeof(EA_RDEV) - 1,  sizeof(uint32_t) + 4, EA_RDEV,  EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(Core.offFlags,  Core.offGen),   FEA_NEEDEA,  sizeof(EA_GEN) - 1,   sizeof(uint32_t) + 4, EA_GEN,   EAT_BINARY, sizeof(uint32_t), 0, "",
-        OFF(offSymlink,     Core.offFlags), FEA_NEEDEA,  sizeof(EA_FLAGS) - 1, sizeof(uint32_t) + 4, EA_FLAGS, EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offGID,    Core.offUID),   0,  sizeof(EA_UID) - 1,   sizeof(uint32_t) + 4, EA_UID,   EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offMode,   Core.offGID),   0,  sizeof(EA_GID) - 1,   sizeof(uint32_t) + 4, EA_GID,   EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offINO,    Core.offMode),  0,  sizeof(EA_MODE) - 1,  sizeof(uint32_t) + 4, EA_MODE,  EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offRDev,   Core.offINO),   0,  sizeof(EA_INO) - 1,   sizeof(uint64_t) + 4, EA_INO,   EAT_BINARY, sizeof(uint64_t), 0, "",
+        OFF(Core.offGen,    Core.offRDev),  0,  sizeof(EA_RDEV) - 1,  sizeof(uint32_t) + 4, EA_RDEV,  EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(Core.offFlags,  Core.offGen),   0,  sizeof(EA_GEN) - 1,   sizeof(uint32_t) + 4, EA_GEN,   EAT_BINARY, sizeof(uint32_t), 0, "",
+        OFF(offSymlink,     Core.offFlags), 0,  sizeof(EA_FLAGS) - 1, sizeof(uint32_t) + 4, EA_FLAGS, EAT_BINARY, sizeof(uint32_t), 0, "",
     },
-    0,                                      FEA_NEEDEA,  sizeof(EA_SYMLINK) - 1, 0              + 4, EA_SYMLINK,EAT_ASCII, 0,                ""
+    0,                                      0,  sizeof(EA_SYMLINK) - 1, 0              + 4, EA_SYMLINK,EAT_ASCII, 0,                ""
 #undef OFF
 };
Index: /trunk/libc/src/kNIX/os2/fhOS2File.c
===================================================================
--- /trunk/libc/src/kNIX/os2/fhOS2File.c	(revision 3777)
+++ /trunk/libc/src/kNIX/os2/fhOS2File.c	(revision 3778)
@@ -632,5 +632,5 @@
                 } EAs =
                 {
-                    sizeof(EAs), 0, FEA_NEEDEA, sizeof(EA_MODE) - 1, sizeof(uint32_t) + 4, EA_MODE, EAT_BINARY, sizeof(uint32_t), fMode
+                    sizeof(EAs), 0, 0, sizeof(EA_MODE) - 1, sizeof(uint32_t) + 4, EA_MODE, EAT_BINARY, sizeof(uint32_t), fMode
                 };
                 #pragma pack()
Index: /trunk/libc/src/kNIX/os2/fs-os2.c
===================================================================
--- /trunk/libc/src/kNIX/os2/fs-os2.c	(revision 3777)
+++ /trunk/libc/src/kNIX/os2/fs-os2.c	(revision 3778)
@@ -135,11 +135,11 @@
 #define OFF(a,b)  offsetof(struct __LIBC_FSUNIXATTRIBSCREATEFEA2LIST, a)  - offsetof(struct __LIBC_FSUNIXATTRIBSCREATEFEA2LIST, b)
     sizeof(__libc_gFsUnixAttribsCreateFEA2List),
-    OFF(offGID,    offUID),   FEA_NEEDEA,  sizeof(EA_UID) - 1,   sizeof(uint32_t) + 4, EA_UID,   EAT_BINARY, sizeof(uint32_t), 0, "",
-    OFF(offMode,   offGID),   FEA_NEEDEA,  sizeof(EA_GID) - 1,   sizeof(uint32_t) + 4, EA_GID,   EAT_BINARY, sizeof(uint32_t), 0, "",
-    OFF(offINO,    offMode),  FEA_NEEDEA,  sizeof(EA_MODE) - 1,  sizeof(uint32_t) + 4, EA_MODE,  EAT_BINARY, sizeof(uint32_t), 0, "",
-    OFF(offRDev,   offINO),   FEA_NEEDEA,  sizeof(EA_INO) - 1,   sizeof(uint64_t) + 4, EA_INO,   EAT_BINARY, sizeof(uint64_t), 0, "",
-    OFF(offGen,    offRDev),  FEA_NEEDEA,  sizeof(EA_RDEV) - 1,  sizeof(uint32_t) + 4, EA_RDEV,  EAT_BINARY, sizeof(uint32_t), 0, "",
-    OFF(offFlags,  offGen),   FEA_NEEDEA,  sizeof(EA_GEN) - 1,   sizeof(uint32_t) + 4, EA_GEN,   EAT_BINARY, sizeof(uint32_t), 0, "",
-    0,                        FEA_NEEDEA,  sizeof(EA_FLAGS) - 1, sizeof(uint32_t) + 4, EA_FLAGS, EAT_BINARY, sizeof(uint32_t), 0, ""
+    OFF(offGID,    offUID),   0,  sizeof(EA_UID) - 1,   sizeof(uint32_t) + 4, EA_UID,   EAT_BINARY, sizeof(uint32_t), 0, "",
+    OFF(offMode,   offGID),   0,  sizeof(EA_GID) - 1,   sizeof(uint32_t) + 4, EA_GID,   EAT_BINARY, sizeof(uint32_t), 0, "",
+    OFF(offINO,    offMode),  0,  sizeof(EA_MODE) - 1,  sizeof(uint32_t) + 4, EA_MODE,  EAT_BINARY, sizeof(uint32_t), 0, "",
+    OFF(offRDev,   offINO),   0,  sizeof(EA_INO) - 1,   sizeof(uint64_t) + 4, EA_INO,   EAT_BINARY, sizeof(uint64_t), 0, "",
+    OFF(offGen,    offRDev),  0,  sizeof(EA_RDEV) - 1,  sizeof(uint32_t) + 4, EA_RDEV,  EAT_BINARY, sizeof(uint32_t), 0, "",
+    OFF(offFlags,  offGen),   0,  sizeof(EA_GEN) - 1,   sizeof(uint32_t) + 4, EA_GEN,   EAT_BINARY, sizeof(uint32_t), 0, "",
+    0,                        0,  sizeof(EA_FLAGS) - 1, sizeof(uint32_t) + 4, EA_FLAGS, EAT_BINARY, sizeof(uint32_t), 0, ""
 #undef OFF
 };