Index: /trunk/libc/include/InnoTekLIBC/fork.h
===================================================================
--- /trunk/libc/include/InnoTekLIBC/fork.h	(revision 3795)
+++ /trunk/libc/include/InnoTekLIBC/fork.h	(revision 3796)
@@ -412,5 +412,5 @@
      * This is only set when fork() is called from threads other than 1. */
     int                     fStackAlloc;
-    /** Pointer to the instruction starint the return sequence for __fork().
+    /** Pointer to the instruction starting the return sequence for __fork().
      * Pratically speaking, set esp=pvStackRet and jump here. */
     void                   *pvForkRet;
Index: /trunk/libc/src/kNIX/os2/libcfork.c
===================================================================
--- /trunk/libc/src/kNIX/os2/libcfork.c	(revision 3795)
+++ /trunk/libc/src/kNIX/os2/libcfork.c	(revision 3796)
@@ -487,5 +487,5 @@
         /*
          * Don't deregister modules which has already been deregistered.
-         * Don't deregister if we're in shutting down the process (waste 
+         * Don't deregister if we're in shutting down the process (waste
          * of time and SPM will already be shut down).
          */
@@ -615,5 +615,5 @@
 
     /*
-     * Determin fxsave/fxrstor support.
+     * Determine fxsave/fxrstor support.
      */
     static int fHaveFXSR = -1;
@@ -762,5 +762,5 @@
     /*
      * Check if we have an executable in the module list.
-     * It's impossible to pull of a fork without the executable being ready for it!
+     * It's impossible to pull off a fork without the executable being ready for it!
      */
     if (forkParCanFork(pModules))
@@ -1022,6 +1022,6 @@
  * will go directly into wait on the mutex. I.e. the event sems are only used
  * for accessing the mutex, and the mutex is the semaphore to wait on. This is
- * much more reliable than sleeping on event sems, since mutex sems gets
- * invalidate if an owner dies.
+ * much more reliable than sleeping on event sems, since mutex sems get
+ * invalidated if an owner dies.
  *
  * The handle is created with buffer flushing disabled.
@@ -1196,5 +1196,5 @@
  * child run.
  *
- * The for buffer will be released before DosExecPgm() so the child can
+ * The fork buffer will be released before DosExecPgm() so the child can
  * do init time processing of the DosEx stuff for instance. After DosExecPgm()
  * we'll be wait on the event semaphore and subseqently on the mutex till
@@ -2452,5 +2452,5 @@
 
     /*
-     * Rest the buffer.
+     * Reset the buffer.
      */
     if (rc >= 0)
Index: /trunk/libc/src/kNIX/os2/sharedpm.c
===================================================================
--- /trunk/libc/src/kNIX/os2/sharedpm.c	(revision 3795)
+++ /trunk/libc/src/kNIX/os2/sharedpm.c	(revision 3796)
@@ -464,5 +464,5 @@
             LIBCLOG_MSG("posting %#lx\n", gpSPMHdr->hevNotify);
             APIRET rc2 = DosPostEventSem(gpSPMHdr->hevNotify);
-            spmReleaseMutex(&RegRec); 
+            spmReleaseMutex(&RegRec);
             LIBC_ASSERTM(!rc2 || rc2 == ERROR_ALREADY_POSTED, "rc2=%ld!\n", rc2); rc2 = rc2;
         }
@@ -600,5 +600,5 @@
 
 /**
- * Wait for a embryo to become a live process and complete 
+ * Wait for a embryo to become a live process and complete
  * inheriting (file handles / sockets issues).
  *
@@ -617,18 +617,18 @@
     DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, &ulStart, sizeof(ulStart));
 
-    /* 
+    /*
      * Wait for the process to become ready, 8 ms max.
-     * However, if it becomes alive in that period we know it's a libc 
+     * However, if it becomes alive in that period we know it's a libc
      * process and will wait a bit more (130 ms) for it to finishing
      * initialization and inheritance.
      */
-    for (cLoops = 0; ; cLoops++) 
-    {
-        /* 
-         * Reset the notification event sem. 
+    for (cLoops = 0; ; cLoops++)
+    {
+        /*
+         * Reset the notification event sem.
          */
         spmRequestMutex(&RegRec);
         fAlive = pEmbryo->enmState > __LIBC_PROCSTATE_ALIVE
-              || (   pEmbryo->pInherit == NULL 
+              || (   pEmbryo->pInherit == NULL
                   && pEmbryo->pInheritLocked == NULL
                   && pEmbryo->enmState == __LIBC_PROCSTATE_ALIVE);
@@ -639,6 +639,6 @@
             break; /* done */
 
-        /* 
-         * Calc the time we should sleep. 
+        /*
+         * Calc the time we should sleep.
          */
         ULONG ulNow = 0;
@@ -659,12 +659,12 @@
             LIBCLOG_MSG("libc child - wait %lu ms (cLoops=%d rc=%ld)\n", ulSleep, cLoops, rc);
         }
-        else 
+        else
             break; /* giving up */
 
-        /* 
-         * Recheck before going to sleep on the event sem. 
+        /*
+         * Recheck before going to sleep on the event sem.
          */
         fAlive = pEmbryo->enmState > __LIBC_PROCSTATE_ALIVE
-              || (   pEmbryo->pInherit == NULL 
+              || (   pEmbryo->pInherit == NULL
                   && pEmbryo->pInheritLocked == NULL
                   && pEmbryo->enmState == __LIBC_PROCSTATE_ALIVE);
@@ -672,5 +672,5 @@
             break; /* done */
 
-        if (    gpSPMHdr->hevNotify 
+        if (    gpSPMHdr->hevNotify
             &&  (rc == NO_ERROR || rc == ERROR_TIMEOUT || rc == ERROR_SEM_TIMEOUT))
             rc = DosWaitEventSem(gpSPMHdr->hevNotify, ulSleep);
@@ -2633,5 +2633,5 @@
                     *pParent->ppChildNotifyTail = pTerm;
                     pParent->ppChildNotifyTail = &pTerm->pNext;
-                    
+
                     LIBCLOG_MSG("posting %#lx\n", gpSPMHdr->hevNotify);
                     APIRET rc2 = DosPostEventSem(gpSPMHdr->hevNotify);
@@ -3462,5 +3462,5 @@
                     spmFreeProcess(pProcess);
                     pProcess = pProcessNext;
-                    
+
                     /* Wake up the embryo waiters (paranoia). */
                     LIBCLOG_MSG("posting %#lx\n", gpSPMHdr->hevNotify);
@@ -3558,5 +3558,5 @@
                         spmFreeProcess(pProcess);
                         pProcess = pProcessNext;
-                        
+
                         /* Wake up the embryo waiters (paranoia). */
                         LIBCLOG_MSG("posting %#lx\n", gpSPMHdr->hevNotify);
Index: /trunk/libc/src/kNIX/os2/signals.c
===================================================================
--- /trunk/libc/src/kNIX/os2/signals.c	(revision 3795)
+++ /trunk/libc/src/kNIX/os2/signals.c	(revision 3796)
@@ -848,5 +848,5 @@
 
     /*
-     * Can't be to careful!
+     * Can't be too careful!
      */
     LIBC_ASSERTM(!__libc_back_signalSemIsOwner(), "Thread owns the signal semaphore!!! Bad boy!!\n");