Index: /trunk/libc/src/glibc/crypt/crypt-entry.c
===================================================================
--- /trunk/libc/src/glibc/crypt/crypt-entry.c	(revision 3827)
+++ /trunk/libc/src/glibc/crypt/crypt-entry.c	(revision 3828)
@@ -49,5 +49,5 @@
 /* Prototypes for local functions.  */
 #if __STDC__ - 0
-#if !defined __GNU_LIBRARY__ && !defined __INNOTEK_LIBC__
+#if !defined __GNU_LIBRARY__ && !defined(__KLIBC__)
 void _ufc_clearmem (char *start, int cnt);
 #else
@@ -81,5 +81,5 @@
   ufc_long xx = 25; /* to cope with GCC long long compiler bugs */
 
-#if defined _LIBC || defined __INNOTEK_LIBC__
+#if defined _LIBC || defined(__KLIBC__)
   /* Try to find out whether we have to use MD5 encryption replacement.  */
   if (strncmp (md5_salt_prefix, salt, sizeof (md5_salt_prefix) - 1) == 0)
@@ -124,5 +124,5 @@
      const char *salt;
 {
-#if defined _LIBC || defined __INNOTEK_LIBC__
+#if defined _LIBC || defined(__KLIBC__)
   /* Try to find out whether we have to use MD5 encryption replacement.  */
   if (strncmp (md5_salt_prefix, salt, sizeof (md5_salt_prefix) - 1) == 0)
@@ -138,5 +138,5 @@
  * They don't need to call init_des.
  */
-#if defined _LIBC || defined __INNOTEK_LIBC__
+#if defined _LIBC || defined(__KLIBC__)
 weak_alias (crypt, fcrypt)
 #else
Index: /trunk/libc/src/glibc/crypt/crypt_util.c
===================================================================
--- /trunk/libc/src/glibc/crypt/crypt_util.c	(revision 3827)
+++ /trunk/libc/src/glibc/crypt/crypt_util.c	(revision 3828)
@@ -50,5 +50,5 @@
 /* Prototypes for local functions.  */
 #if __STDC__ - 0
-#if !defined(__GNU_LIBRARY__) && !defined(__INNOTEK_LIBC__)
+#if !defined(__GNU_LIBRARY__) && !defined(__KLIBC__)
 void _ufc_clearmem (char *start, int cnt);
 void _ufc_copymem (char *from, char *to, int cnt);
@@ -268,5 +268,5 @@
 __libc_lock_define_initialized (static, _ufc_tables_lock)
 #endif
-#ifdef __INNOTEK_LIBC__
+#ifdef __KLIBC__
 #include <sys/smutex.h>
 #endif
@@ -274,5 +274,5 @@
 
 
-#if defined(DEBUG) && !defined(__INNOTEK_LIBC__)
+#if defined(DEBUG) && !defined(__KLIBC__)
 
 void
@@ -309,5 +309,5 @@
 #endif
 
-#if !defined(__GNU_LIBRARY__) && !defined(__INNOTEK_LIBC__)
+#if !defined(__GNU_LIBRARY__) && !defined(__KLIBC__)
 /*
  * Silly rewrites of 'bzero'/'memset'. I do so
@@ -375,5 +375,5 @@
       goto small_tables_done;
 #endif
-#ifdef __INNOTEK_LIBC__
+#ifdef __KLIBC__
     static _smutex smtx;
     _smutex_request(&smtx);
@@ -488,5 +488,5 @@
     __libc_lock_unlock(_ufc_tables_lock);
 #endif
-#ifdef __INNOTEK_LIBC__
+#ifdef __KLIBC__
 small_tables_done:
     _smutex_release(&smtx);
Index: /trunk/libc/src/glibc/crypt/md5-crypt.c
===================================================================
--- /trunk/libc/src/glibc/crypt/md5-crypt.c	(revision 3827)
+++ /trunk/libc/src/glibc/crypt/md5-crypt.c	(revision 3828)
@@ -264,5 +264,5 @@
 }
 
-#if !defined _LIBC && !defined __INNOTEK_LIBC__
+#if !defined _LIBC && !defined(__KLIBC__)
 static void
 __attribute__ ((__destructor__))
Index: /trunk/libc/src/glibc/crypt/md5.c
===================================================================
--- /trunk/libc/src/glibc/crypt/md5.c	(revision 3827)
+++ /trunk/libc/src/glibc/crypt/md5.c	(revision 3828)
@@ -29,5 +29,5 @@
 #include <sys/types.h>
 
-#if STDC_HEADERS || defined _LIBC || defined __INNOTEK_LIBC__
+#if STDC_HEADERS || defined _LIBC || defined(__KLIBC__)
 # include <stdlib.h>
 # include <string.h>
@@ -40,5 +40,5 @@
 #include "md5.h"
 
-#if defined _LIBC || defined __INNOTEK_LIBC__
+#if defined _LIBC || defined(__KLIBC__)
 # include <endian.h>
 # if __BYTE_ORDER == __BIG_ENDIAN
Index: /trunk/libc/src/glibc/crypt/md5.h
===================================================================
--- /trunk/libc/src/glibc/crypt/md5.h	(revision 3827)
+++ /trunk/libc/src/glibc/crypt/md5.h	(revision 3828)
@@ -24,5 +24,5 @@
 #include <stdio.h>
 
-#if defined HAVE_LIMITS_H || (defined _LIBC && _LIBC) || defined(__INNOTEK_LIBC__)
+#if defined HAVE_LIMITS_H || (defined _LIBC && _LIBC) || defined(__KLIBC__)
 # include <limits.h>
 #endif
@@ -35,5 +35,5 @@
    is usually not possible.  */
 
-#if defined _LIBC || defined __INNOTEK_LIBC__
+#if defined _LIBC || defined(__KLIBC__)
 # include <stdint.h>
 typedef uint32_t md5_uint32;
Index: /trunk/libc/src/glibc/malloc/obstack.c
===================================================================
--- /trunk/libc/src/glibc/malloc/obstack.c	(revision 3827)
+++ /trunk/libc/src/glibc/malloc/obstack.c	(revision 3828)
@@ -90,5 +90,5 @@
 /* Exit value used when `print_and_abort' is used.  */
 # include <stdlib.h>
-# if defined _LIBC || defined __INNOTEK_LIBC__
+# if defined _LIBC || defined(__KLIBC__)
 int obstack_exit_failure = EXIT_FAILURE;
 # else
@@ -386,5 +386,5 @@
 
 /* Define the error handler.  */
-#ifndef __INNOTEK_LIBC__
+#ifndef __KLIBC__
 # ifdef _LIBC
 #  include <libintl.h>
@@ -395,8 +395,8 @@
 #  define _(msgid) gettext (msgid)
 # endif
-#else /* __INNOTEK_LIBC__ */
+#else /* __KLIBC__ */
 # undef _
 # define _(x)  (x)
-#endif /* __INNOTEK_LIBC__ */
+#endif /* __KLIBC__ */
 
 
Index: /trunk/libc/src/glibc/posix/getopt.c
===================================================================
--- /trunk/libc/src/glibc/posix/getopt.c	(revision 3827)
+++ /trunk/libc/src/glibc/posix/getopt.c	(revision 3828)
@@ -56,5 +56,5 @@
 /* This needs to come after some library #include
    to get __GNU_LIBRARY__ defined.  */
-#if defined __GNU_LIBRARY__ || defined __INNOTEK_LIBC__
+#if defined __GNU_LIBRARY__ || defined(__KLIBC__)
 /* Don't include stdlib.h for non-GNU C libraries because some of them
    contain conflicting prototypes for getopt.  */
@@ -69,5 +69,5 @@
 #endif
 
-#ifndef __INNOTEK_LIBC__
+#ifndef __KLIBC__
 #ifndef	_LIBC
 # include <libintl.h>
@@ -76,7 +76,7 @@
 # define _(msgid) gettext (msgid)
 #endif
-#else /* __INNOTEK_LIBC__ */
+#else /* __KLIBC__ */
 # define _(msgid) msgid
-#endif /* __INNOTEK_LIBC__ */
+#endif /* __KLIBC__ */
 
 #if defined _LIBC && defined USE_IN_LIBIO
Index: /trunk/libc/src/glibc/posix/regcomp.c
===================================================================
--- /trunk/libc/src/glibc/posix/regcomp.c	(revision 3827)
+++ /trunk/libc/src/glibc/posix/regcomp.c	(revision 3828)
@@ -641,5 +641,5 @@
    them unless specifically requested.  */
 
-#if defined _REGEX_RE_COMP || defined _LIBC || defined __INNOTEK_LIBC__
+#if defined _REGEX_RE_COMP || defined _LIBC || defined(__KLIBC__)
 
 /* BSD has one and only one pattern buffer.  */
Index: /trunk/libc/src/glibc/posix/regex_internal.h
===================================================================
--- /trunk/libc/src/glibc/posix/regex_internal.h	(revision 3827)
+++ /trunk/libc/src/glibc/posix/regex_internal.h	(revision 3828)
@@ -46,5 +46,5 @@
 # include <stdint.h>
 #endif /* HAVE_STDINT_H || _LIBC */
-#if defined _LIBC || defined __INNOTEK_LIBC__
+#if defined _LIBC || defined(__KLIBC__)
 # include <bits/libc-lock.h>
 #else
@@ -70,5 +70,5 @@
 
 /* This is for other GNU distributions with internationalized messages.  */
-#if !defined(__INNOTEK_LIBC__) && (HAVE_LIBINTL_H && ENABLE_NLS) || defined _LIBC
+#if !defined(__KLIBC__) && (HAVE_LIBINTL_H && ENABLE_NLS) || defined _LIBC
 # include <libintl.h>
 # ifdef _LIBC
@@ -92,5 +92,5 @@
 #endif
 
-#ifndef __INNOTEK_LIBC__
+#ifndef __KLIBC__
 #if (defined MB_CUR_MAX && HAVE_LOCALE_H && HAVE_WCTYPE_H && HAVE_WCHAR_H && HAVE_WCRTOMB && HAVE_MBRTOWC && HAVE_WCSCOLL) || _LIBC
 # define RE_ENABLE_I18N
@@ -383,5 +383,5 @@
 
 #ifndef _LIBC
-# if defined __i386__ && !defined __INNOTEK_LIBC__
+# if defined __i386__ && !defined(__KLIBC__)
 #  define internal_function   __attribute ((regparm (3), stdcall))
 # else
Index: /trunk/libc/src/glibc/posix/regexec.c
===================================================================
--- /trunk/libc/src/glibc/posix/regexec.c	(revision 3827)
+++ /trunk/libc/src/glibc/posix/regexec.c	(revision 3828)
@@ -596,5 +596,5 @@
    them unless specifically requested.  */
 
-#if defined _REGEX_RE_COMP || defined _LIBC || __INNOTEK_LIBC__
+#if defined _REGEX_RE_COMP || defined _LIBC || __KLIBC__
 int
 # ifdef _LIBC
Index: /trunk/libc/src/glibc/sysdeps/generic/math_private.h
===================================================================
--- /trunk/libc/src/glibc/sysdeps/generic/math_private.h	(revision 3827)
+++ /trunk/libc/src/glibc/sysdeps/generic/math_private.h	(revision 3828)
@@ -1,4 +1,4 @@
 #include "../../../msun/src/math_private.h"
-#ifdef __INNOTEK_LIBC__
+#ifdef __KLIBC__
 # define strong_alias(name, aliasname) _strong_alias(name, aliasname)
 # define _strong_alias(name, aliasname) \
Index: /trunk/libc/src/glibc/sysdeps/generic/w_lgammal.c
===================================================================
--- /trunk/libc/src/glibc/sysdeps/generic/w_lgammal.c	(revision 3827)
+++ /trunk/libc/src/glibc/sysdeps/generic/w_lgammal.c	(revision 3828)
@@ -36,5 +36,5 @@
 #endif
 {
-#if defined _IEEE_LIBM || defined __INNOTEK_LIBC__
+#if defined _IEEE_LIBM || defined(__KLIBC__)
 	return __ieee754_lgammal_r(x,&signgam);
 #else
Index: /trunk/libc/src/glibc/sysdeps/generic/w_tgammaf.c
===================================================================
--- /trunk/libc/src/glibc/sysdeps/generic/w_tgammaf.c	(revision 3827)
+++ /trunk/libc/src/glibc/sysdeps/generic/w_tgammaf.c	(revision 3828)
@@ -34,5 +34,5 @@
 	y = __ieee754_gammaf_r(x,&local_signgam);
 	if (local_signgam < 0) y = -y;
-#if defined _IEEE_LIBM || defined __INNOTEK_LIBC__
+#if defined _IEEE_LIBM || defined(__KLIBC__)
 	return y;
 #else
Index: /trunk/libc/src/glibc/sysdeps/generic/w_tgammal.c
===================================================================
--- /trunk/libc/src/glibc/sysdeps/generic/w_tgammal.c	(revision 3827)
+++ /trunk/libc/src/glibc/sysdeps/generic/w_tgammal.c	(revision 3828)
@@ -39,5 +39,5 @@
 	y = __ieee754_gammal_r(x,&local_signgam);
 	if (local_signgam < 0) y = -y;
-#if defined _IEEE_LIBM || defined __INNOTEK_LIBC__
+#if defined _IEEE_LIBM || defined(__KLIBC__)
 	return y;
 #else